// **************************
//    USB-ADC XBeeڑ1
// **************************
//	V1.00	2010.12.16
//
/*************************************
	XBeeύXځiftHgj
	MY : 1 or 2 or 3
	DL : 0(default)
	SM : 2
	GT : C8
*************************************/

/** INCLUDES *******************************************************/
#include	"./USB/usb.h"
#include	"./USB/usb_function_cdc.h"
#include	"delays.h"
#include	"HardwareProfile.h"
#include	"GenericTypeDefs.h"
#include	"Compiler.h"
#include	"usb_config.h"
#include	"ctype.h"
#include	"ad7793reg.h"

/** CONFIGURATION **************************************************/
        //14K50
        #pragma config CPUDIV = CLKDIV2		// Fosc:24MHz
        #pragma config USBDIV = OFF
        #pragma config FOSC   = HS
        #pragma config PLLEN  = ON
        #pragma config FCMEN  = OFF
        #pragma config IESO   = OFF
        #pragma config PWRTEN = OFF
        #pragma config BOREN  = NOSLP		// Sleepɒ~
        #pragma config BORV   = 27			// 2.7V
//        #pragma config VREGEN = ON
        #pragma config WDTEN  = OFF
        #pragma config WDTPS  = 32768
        #pragma config MCLRE  = OFF
        #pragma config HFOFST = OFF
        #pragma config STVREN = ON
        #pragma config LVP    = OFF
        #pragma config XINST  = OFF
        #pragma config BBSIZ  = OFF
        #pragma config CP0    = OFF
        #pragma config CP1    = OFF
        #pragma config CPB    = OFF
        #pragma config WRT0   = OFF
        #pragma config WRT1   = OFF
        #pragma config WRTB   = OFF
        #pragma config WRTC   = OFF
        #pragma config EBTR0  = OFF
        #pragma config EBTR1  = OFF
        #pragma config EBTRB  = OFF       


// *** CONSTANTS ***
#pragma	code

#include	"version.h"
const rom char	ACKdata[4]="A\r\n";
const rom char	NAKdata[4]="N\r\n";

/** V A R I A B L E S ********************************************************/
#pragma udata

char	USB_In_Buffer[16];		// USB(HostTarget)pobt@
char	USB_Out_Buffer[16];		// USBo(TargetHost)pobt@
char	USB_rxbuf[16];			// USB͈s̓obt@
BYTE	USB_rxcnt;				// USBMJE^
long	USB_txnum;				// USBMf[^
char	adbuf;					// ADϊf[^i[

union  {						// USBMtO
	struct {
		unsigned char	RCVING:1;	// bit0 M:1
		unsigned char	RCVEND:1;	// bit1 MI:1
		unsigned char	RDGDMD:1;	// bit2 f[^ǂݏov:1
		unsigned char	CNVEND:1;	// ϊ/ǂݏoI:1
	};
	unsigned char data;
} USB_trflag;

union {
	struct {
		unsigned char	USBACV:1;	// USBANeBu:1
	};
	unsigned char data;
} USB_flag;

unsigned char	strg[8];		// ėp񏈗obt@
unsigned	ADconv_cnt;			// ADϊ񐔊i[(gp)
unsigned	timec;				// 1mSEFCg[`p
long		ad_result;			// ADϊf[^i[(gp) 
unsigned	frtimer;			// p[ONȍ~A1mSƂɃJEgAbv

//*** User Define ***
#define	ERR		0
#define	NOERR	1

/** P R I V A T E  P R O T O T Y P E S ***************************************/
static void InitializeSystem(void);
void	State1_Process(void);
void	ProcessIO(void);
void	USBDeviceTasks(void);
void	YourHighPriorityISRCode();
void	YourLowPriorityISRCode();
void	BlinkUSBStatus(void);
void	UserInit(void);
void	send_data(long send_data,char *cp);
char	htoc(int ch);
char	SSPtrans(char sch);
char	command_analize(void);
char	ad_command(void);
char	adread_command(void);
char	port_command(void);
char	uart_command(void);
char	pwm_command(void);
int		ctoh(char ch);
int		hex2int(char *ptr);
char	*int2hex(unsigned char ch,char *cp);
void	USB_error_responce(void);
long	htol(char *cp);
void	mon(int pt);
char	pv_read(void);
char	version(void);
void	AD_reset(void);
void	wait_timec(unsigned n);
void	usart_data_tx(char ch);
char	usart_data_rx(void);
void	putUSART(char *buf,int n);
void	putrsUSART(const rom char *cp);
void	putrsU(const rom char *cp);
void	putU(char *cp,int n);

/** VECTOR REMAPPING ***********************************************/
#if defined(__18CXX)
	#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)
		#define REMAPPED_RESET_VECTOR_ADDRESS			0x100
		#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x108
		#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x118
	#elif defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)	
//		#define REMAPPED_RESET_VECTOR_ADDRESS			0x800
//		#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x808
//		#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x818
	#else	
//		#define REMAPPED_RESET_VECTOR_ADDRESS			0x00
//		#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x08
//		#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x18
	#endif
	
	#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)
	extern void _startup (void);        // See c018i.c in your C18 compiler dir
	#pragma code REMAPPED_RESET_VECTOR = REMAPPED_RESET_VECTOR_ADDRESS
	void _reset (void)
	{
	    _asm goto _startup _endasm
	}
	#endif
	#pragma code REMAPPED_HIGH_INTERRUPT_VECTOR = REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS
	void Remapped_High_ISR (void)
	{
	     _asm goto YourHighPriorityISRCode _endasm
	}
	#pragma code REMAPPED_LOW_INTERRUPT_VECTOR = REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS
	void Remapped_Low_ISR (void)
	{
	     _asm goto YourLowPriorityISRCode _endasm
	}
	
	#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)
	#pragma code HIGH_INTERRUPT_VECTOR = 0x08
	void High_ISR (void)
	{
	     _asm goto REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS _endasm
	}
	#pragma code LOW_INTERRUPT_VECTOR = 0x18
	void Low_ISR (void)
	{
	     _asm goto REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS _endasm
	}
	#endif	//end of "#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_LEGACY_CUSTOM_CLASS_BOOTLOADER)"

	#pragma code
	
	
	// *** D抄荞 ***
	#pragma interrupt YourHighPriorityISRCode
	void YourHighPriorityISRCode()
	{
		static int	i;
		char	rch,*cpd;
 		// *** Timer0 1mSTCN荞ݏ ***
		if  (INTCONbits.TMR0IF) {			// Timer0 ?
			TMR0L = 0x89;    
			TMR0H = 0xfe;					// TMR0Ɏc375Zbg
			adbuf = ADRESH;					// 8rbĝݎgp
			if(timec != 0) timec--;			// EFCgpJE^0łȂ-1
			if(frtimer<65535) frtimer++;	// t[jOJE^+1ƃI[o[t[h~
			INTCONbits.TMR0IF = 0;			// ^C}0荞݃tONA
			ADCON0bits.GO = 1;				// PICADϊX^[g
		}
		if (PIR1bits.RCIF) {				// USARTM荞
			rch = RCREG;
			if (RCSTAbits.FERR==1) {
				RCSTAbits.FERR=0;
			} else if (USB_trflag.RCVEND == 0) {			// M񂪂܂ĂȂꍇAXLbv
				if((USB_rxcnt)>sizeof(USB_rxbuf)) {
//					USB_error_responce();		// I[o[?
					USB_rxcnt = 0;
					USB_trflag.data &= ~0x3;
				} else {
					cpd = USB_rxbuf+USB_rxcnt;
					USB_rxcnt++;
					if ((rch == 0xa) || (rch == 0xd) || (rch == '\0')) {
						*cpd = '\0';
						USB_trflag.RCVEND = 1;			// MItO
					} else if ((rch == '+') || (rch == 0x3)) {
						// MfR}h
						USB_trflag.data = 0;
						USB_txnum = 0L;					// Mf
						USB_rxcnt = 0;
					} else if (rch == 0x18) {			// ^X(ESC)R[hAD7793Zbg
						AD_reset();
						USB_trflag.data = 0;
						USB_txnum = 0L;					// Mf
						USB_rxcnt = 0;
					} else {
						if (islower(rch)!=0) rch=toupper(rch);	// 啶ɕϊ
						*cpd = rch;
					}
				}
			}
//			PIR1bits.RCIF = 0;
LATCbits.LATC2=0;
		}
        #if defined(USB_INTERRUPT)			// 荞݂ɂUSB͎gȂ(=|[O[h)
	        USBDeviceTasks();
        #endif
	}

	// *** D抄荞 ***
	#pragma interruptlow YourLowPriorityISRCode
	void YourLowPriorityISRCode()
	{
	}
#endif

/** DECLARATIONS ***************************************************/
#pragma code

void main(void)
{   
	char	StateFlag;
    InitializeSystem();

    #if defined(USB_INTERRUPT)
        USBDeviceAttach();			// ̃[`͌Ă΂Ȃ
    #endif

	StateFlag = 0;
    while(1)
    {
		#if defined(USB_POLLING)	// USB̓|[O[hŎg
		USBDeviceTasks(); // Interrupt or polling method.  If using polling, must call
		#endif
		// ϐStateFlagɂXe[g}V\z
		if(StateFlag==0) {
		// Xe[g0͏Xe[g Ԃ鏉Ɏgp
			State1_Process();
			StateFlag=1;
		}
		if(StateFlag==1) {
			ProcessIO();        
		}

	}
}//end main

#define	AD_CS	LATCbits.LATC6	// AD7793 /CS
#define	AD_RDY	PORTBbits.SDI	// AD7793 /RDY

//********************************
//  SPIM
//********************************
// Entry	sch : M
// Exit	M
// M̎̓_~[𑗐M
char	SSPtrans(char sch)
{
	char	rch;

	SSPBUF = sch;				// f[^
	while(SSPSTATbits.BF==0);	// M҂
	rch = SSPBUF;				// f[^ǂݏo
	PIR1bits.SSPIF = 0;			// SSPIF clear
	return(rch);
}

// **************
//    Xe[g
// **************

// *** 1Xe[g(gp) ***
void	State0_Process(void)
{
}

// *** 2Xe[g ***
void	State1_Process(void)
{
	char	rch;

	AD_CS = 0;
	Nop();	    				// fBC
	rch = SSPtrans(0x08);		// [hWX^ Write Command
	rch = SSPtrans(0x00);		// Aϊ
	rch = SSPtrans(0x0a);		// CLKA16.7Hz
	Nop();
	rch = SSPtrans(0x10);		// ݒ背WX^ Write Command
	rch = SSPtrans(0x50);		// VBias1 on,*1,Unipoler
	rch = SSPtrans(0x83);		// IntRef,nonBuf,Ain1-Ain1
	AD_CS = 1;
}

// *** CXe[g ***
void ProcessIO(void)
{   
	BYTE		numBytesRead;
	char	rch,i,*cps,*cpd,rt,ch;
	long	lval;

	// ϊf[^AD7793ǂݏo
	AD_CS = 0;
	Nop();			    				// fBC
	if (AD_RDY==0) {					// ϊIH
		rch = SSPtrans(0x58);			// Data Reg Read Command
		rch = SSPtrans(0x00);
		data_reg.byte_data[2] = rch;
		rch = SSPtrans(0x00);
		data_reg.byte_data[1] = rch;
		rch = SSPtrans(0x00);
		data_reg.byte_data[0] = rch;
		USB_trflag.CNVEND = 1;
	}
	AD_CS = 1;

	// USBڑ̃^XN
	if((USBDeviceState >= CONFIGURED_STATE) && (USBSuspendControl!=1)) {
		USB_flag.USBACV = 1;
		// USBM
		if (mUSBUSARTIsTxTrfReady()) {
			if (USB_trflag.RDGDMD==1) {			// PC̕ϊf[^ǂݏovH
				if (USB_trflag.CNVEND==1) {		// ϊf[^H
					for(i=0,cpd=USB_Out_Buffer;i<3;i++) {
						cpd = int2hex(data_reg.byte_data[2-i],cpd);
					}
					*cpd++ = 0xd;
					*cpd++ = 0xa;
					*cpd++ = '\0';
					USB_trflag.CNVEND = 0;
					putU(USB_Out_Buffer,8);
					if (--USB_txnum <= 0L) {
						USB_trflag.RDGDMD = 0;
						USB_txnum = 0;
					}
				}
			}
			// USBM^XN
			if (USB_trflag.RCVEND == 0) {			// M񂪂܂ĂȂꍇAXLbv
				numBytesRead = getsUSBUSART(USB_In_Buffer,32);
				if(numBytesRead != 0) {				// M?
					if((numBytesRead+USB_rxcnt)>=sizeof(USB_rxbuf)) {
						USB_error_responce();		// I[o[?
						USB_rxcnt = 0;
						USB_trflag.data &= ~0x3;
					} else {
						cpd = USB_rxbuf+USB_rxcnt;
						cps = USB_In_Buffer;
						USB_rxcnt += numBytesRead;
						for(i=0;i<numBytesRead;i++) {
							if ((*cps == 0xa) || (*cps == 0xd) || (*cps == '\0')) {
								*cpd = '\0';
								USB_trflag.RCVEND = 1;			// MItO
								break;
							} else if ((*cps == '+') || (*cps == 0x3)) {	// MfR}h?
								USB_trflag.data = 0;
								USB_txnum = 0L;					// Mf
								USB_rxcnt = 0;
							} else if (*cps == 0x18) {			// ^X(ESC)R[hAD7793Zbg
								AD_reset();
								USB_trflag.data = 0;
								USB_txnum = 0L;					// Mf
								USB_rxcnt = 0;
								// putrsUSBUSART("X\r\n");
							} else {
								if (islower(*cps)!=0) *cps=toupper(*cps);	// 啶ɕϊ
							}
							*cpd++ = *cps++;
						}
					}
				}
			}
			// M̎M񏈗BM̓XLbv
			if (USB_trflag.RCVEND) {
				rt = command_analize();
				USB_trflag.data &= ~0x3;
				USB_rxcnt = 0;
				if(rt==ERR) USB_error_responce();
			}
		}
		CDCTxService();
	} else {
//		if (USBDeviceState >= DEFAULT_STATE) {	// USBڑXe[gȂlq
//			frtimer = 0;
//		}
		if (frtimer>3000) {		// USBؒfԂObȏ㑱H
			PIE1bits.RCIE = 1;		// USART rx interrupt enable
			USB_flag.USBACV = 0;
			// USBؒf(=Od)AX^hA[̓
			if (USB_trflag.RDGDMD==1) {			// PC̕ϊf[^ǂݏovH
				if (USB_trflag.CNVEND==1) {		// ϊf[^H
					for(i=0,cpd=USB_Out_Buffer;i<3;i++) {
						cpd = int2hex(data_reg.byte_data[2-i],cpd);
					}
					*cpd++ = 0xd;
					*cpd++ = 0xa;
					*cpd++ = '\0';
					USB_trflag.CNVEND = 0;
					putUSART(USB_Out_Buffer,8);
					if (--USB_txnum <= 0L) {
						USB_trflag.RDGDMD = 0;
						USB_txnum = 0;
					}
				}
			}
			// M񏈗BM̓XLbv
			if (USB_trflag.RCVEND==1) {
				rt = command_analize();
				USB_trflag.data &= ~0x3;
				USB_rxcnt = 0;
			}
		}
	}
}		//end ProcessIO

// *** AD7793fW^C^[tF[X̃Zbg(32ȏ1) ***
void	AD_reset(void)
{
	char	rch;

	AD_CS = 0;
	Nop();
	rch = SSPtrans(0xff);
	rch = SSPtrans(0xff);
	rch = SSPtrans(0xff);
	rch = SSPtrans(0xff);
	rch = SSPtrans(0xff);	// Ô߂8
	AD_CS = 1;
}

// ********************
//   USBR}h&
// ********************

// *** R}h ***
// return G[:-1
char	command_analize(void)
{
	char	rt;

	switch (USB_rxbuf[0]) {
		case 'E' :  putrsU(ACKdata); break;	// ENQ(ڑmF)R}h
		case 'C' :	rt = ad_command(); break;		// AD7793WX^R}h
		case 'R' :	rt = adread_command(); break;	// ADf[^[hR}h
		case 'P' :	rt = port_command(); break;		// IO|[gANZXR}h
		case 'U' :	rt = uart_command(); break;		// USART (ݒ)
		case 'W' :	rt = pwm_command(); break;		// PWM (ݒ)
		case 'Q' :  rt = pv_read(); break;			// ddǂݏo
		case 'V' :  rt = version(); break;
		default : rt = ERR; break;
	}
	return(rt);
}

// AD7793eWX^̓ǂݏ̃f[^(oCg)
const	rom int	command_length[2][8] = {
	{ 0, 2, 2,-1,-1, 1, 3, 3},	// ݂̑Mf[^
	{ 1, 2, 2, 3, 1, 1, 3, 3}	// ǂݏo̎Mf[^
};

// *** 'C'Ŏn܂AD7793R}h&s ***
// return G[:-1
char	ad_command(void)
{
	char	rt,rxnum,txnum,rch,i;
	char	*cp;

	comu_reg.byte = hex2int(USB_rxbuf+1);	
	rxnum = txnum = 0;
	rt = NOERR;
	// R~jP[VWX^RWƃWX^ԍRS瑗M̃oCg߂
	if (comu_reg.RW==1) {		// Read
		rxnum = command_length[1][comu_reg.RS];
	} else {					// Write
		txnum = command_length[0][comu_reg.RS];
		if (txnum==-1) rt = ERR;
	}
	if (rt) {	// G[ΑMs
		AD_CS = 0;
		Nop();			    						// fBC
		rch = SSPtrans(comu_reg.byte);				// ComunicationWX^
		if(rxnum>0) {								// [hR}h(ǂݏof[^)H
			for(i=0,cp=USB_Out_Buffer;i<rxnum;i++) {
				cp = int2hex(SSPtrans(0x00),cp);	// 2HEXɕϊă|C^+2
			}
			*cp++ = 0xd;
			*cp++ = 0xa;
			*cp   = '\0';
			putU(USB_Out_Buffer,rxnum+rxnum+2);
		}
		if (txnum>0) {								// CgR}h(݃f[^)H
			for(i=0,cp=USB_rxbuf+3;i<txnum;i++) {
				if ((*cp==0xa) || (*cp==0xd) || (*cp==0x0)) {
					rt = ERR;
					return(rt);
				}
				rch = hex2int(cp++);
				cp++;
				rch = SSPtrans(rch);				// oCiϊADɏ
			}
			if ((mode_reg.MD==0) || (mode_reg.MD==3)) {	// AMڍs͑MtONA(d̕sf[^h~)
				USB_trflag.CNVEND = 0;
				USB_trflag.RDGDMD = 0;
			}
			putrsU(ACKdata);
		}
		AD_CS = 1;
		USB_trflag.data &= ~0x3;
	} else {
	}
	return(rt);
}

// *** 'R'Ŏn܂ADf[^[hR}h ***
// return G[:-1
char	adread_command(void)
{
	int	slen,i;

	slen = strlen(USB_rxbuf);
	if (slen == 1) {
		USB_txnum = 1;

	} else {
		USB_txnum = htol(USB_rxbuf+1);
	}
	USB_trflag.RDGDMD = 1;
	return(NOERR);
}

// *** 'P'Ŏn܂|[gR}h ***
// R}hɕt|[gf[^CPU|[g̑Ή
//	Bit0 : RC1
//	Bit1 : RC2
//	Bit2 : RC3
//	Bit3 : RC4
//	Bit4 : RB7
//	Bit5 : RB5
//	Bit6 : RC5
char	port_command(void)
{
	int		pat,rt;
	unsigned char	ch1,ch2;
	char	*cpd;

	rt = NOERR;
	switch (USB_rxbuf[1]) {
		case 'M' :		// In/Out ݒR}h
			pat = hex2int(USB_rxbuf+2);			// 2HEXf[^ǂݍ
			ch1 = ((pat << 1) | 0x1) & 0x1f;	// RC1`4[hZbg	
			if ((pat & 0x40)!=0) ch1 |= 0x20; 	// RC5[hZbg
			TRISC = ch1;
			ch2 = 0x10;
			if ((pat & 0x10)!=0) ch2 |= 0x80;	// RB7[hZbg
			if ((pat & 0x20)!=0) ch2 |= 0x20;	// RB5[hZbg
			TRISB = ch2; 

			putrsU(ACKdata);
			break;
		case 'R' :		// |[g[h
			ch1 = ((PORTC >> 1) & 0x0f) + ((PORTC << 1) & 0x40)
			    + ((PORTB >> 3) & 0x10) + ( PORTB & 0x20);
			cpd=USB_Out_Buffer;
			cpd = int2hex(ch1,cpd);
			*cpd++ = 0xd;
			*cpd++ = 0xa;
			*cpd++ = '\0';
			USB_trflag.CNVEND = 0;
			putU(USB_Out_Buffer,4);
			break;
		case 'W' :		// |[gCg
			pat = hex2int(USB_rxbuf+2);			// 2HEXf[^ǂݍ
			ch1 = (pat << 1) & 0x1e;			// RC1`4Cgf[^Zbg	
			if ((pat & 0x40)!=0) ch1 |= 0x20; 	// RC5Cgf[^Zbg
			LATC = ch1;
			ch2 = 0x10;
			if ((pat & 0x10)!=0) ch2 |= 0x80;	// RB7Cgf[^Zbg
			if ((pat & 0x20)!=0) ch2 |= 0x20;	// RB5Cgf[^Zbg
			LATB = ch2; 

			putrsU(ACKdata);
			break;
		default :
			rt = ERR;
//			putrsUSBUSART("N\r\n");
			break;
	}
	return rt;
}

// *** UARTR}h() ***
char	uart_command(void)
{
}

// *** PWMo̓R}h() ***
char	pwm_command(void) {}

// *** NAK ('N')M ***
void	USB_error_responce(void)
{
	if(mUSBUSARTIsTxTrfReady())
		putrsU(NAKdata);
}

// *** ddǂݏoR}h ***
// 1MdPICADœǂݏo(3.3Vɑ΂1/2d8rbgǂݏo)
// ͒R߁AZŏ_ꌅx̐x
// USBgpUSBoXp[̓do(X^hAp̎Ql)
char	pv_read()
{
	char	*cpd;

	cpd=USB_Out_Buffer;
	if(mUSBUSARTIsTxTrfReady()) {
		cpd = int2hex(adbuf,cpd);
		*cpd++ = 0xd;
		*cpd++ = 0xa;
		*cpd++ = '\0';
		putU(USB_Out_Buffer,4);
		USB_trflag.CNVEND = 0;
	}	
}

// *** o[W(ߍ)R}h ***
char	version(void)
{
	putrsU(version_string);
	return NOERR;
}

// *****************
//    UART֐
// *****************
void	usart_data_tx(char ch)
{
	while(TXSTAbits.TRMT==0) ;
	TXREG = ch;
wait_timec(1);
}

char	usart_data_rx()
{
	while(USB_trflag.RCVING==0);
	USB_trflag.RCVING = 0;
	return(USB_In_Buffer[0]);
}

void	putrsU(const rom char *cp)
{
	if(USB_flag.USBACV==1) {
		putrsUSBUSART(cp);
	} else {
		putrsUSART(cp);
	}
}

void	putU(char *cp,int n)
{
	if(USB_flag.USBACV==1) {
		putUSBUSART(cp,n);
	} else {
		putUSART(cp,n);
	}
}

void	putrsUSART(const rom char *cp)
{
	while(*cp) {
		usart_data_tx(*cp++);
	}
}

void	putUSART(char *buf,int n)
{
	int	i;

	for(i=0;i<n;i++) {
		usart_data_tx(*buf++);
	}
}

// **************
//   ֐
// **************

// *** 1byte(00h-0Fh)PPUi('0'-'F')ɕϊ ***
char	htoc(int ch)
{
	return "0123456789ABCDEF"[ch & 0xf];
}

// *** 1byte16i𐔒lɕϊ ***
int	ctoh(char ch)
{
	if (islower(ch)!=0) ch=toupper(ch);
	if (ch>='A') return(ch-'A'+10); else return(ch-'0');
}

// *** 񒆂2HEXlintɕϊ ***
// Entry	*ptr : w蕶
int	hex2int(char *cp)
{
	int	ctoh();
	char	ch1,ch2;

	ch1 = (ctoh(*cp++)<<4)&0xf0;
	ch2 = ctoh(*cp)&0xf;
	return(ch1+ch2);
}

// *** 1oCgϐ2HEXɕϊA|C^+2 ***
char	*int2hex(unsigned char ch,char *cp)
{
	*cp++ = htoc(ch >> 4);
	*cp++ = htoc(ch & 0xf);
	return(cp);
}

// *** 16i\Llong^ɕϊ ***
long	htol(char *cp)
{
	long	lval = 0;

	while(*cp != '\0') {
		lval = lval << 4;
		lval += ctoh(*cp++);
	}
	return lval;
}

// *** Longf[^6oCgHEXɕϊ^[~l[^t ***
void send_data(long send_data,char *cp)
{
	int i;
	unsigned char uch;

	uch = (send_data >> 20) & 0xf;
	*cp++ = htoc(uch);
	uch = (send_data >> 16) & 0xf;
	*cp++ = htoc(uch);
	uch = (send_data >> 12) & 0xf;
	*cp++ = htoc(uch);
	uch = (send_data >>  8) & 0xf;
	*cp++ = htoc(uch);
	uch = (send_data >>  4) & 0xf;
	*cp++ = htoc(uch);
	uch = (send_data      ) & 0xf;
	*cp++ = htoc(uch);
	*cp++ = 0xd;
	*cp++ = 0xa;
	*cp++ = '\0';
}

// *********
//   G֐
// *********

// *** pulse mon ***
void	mon(int pt)
{
	int	i;
	for(i=0;i<pt;i++) {
		LATCbits.LATC2 = 1;
		LATCbits.LATC2 = 0;
	}
}

// 1ms~n@EFCg
void	wait_timec(unsigned n)
{
	timec = n;
	while (timec!=0);
}

// *********
//   
// *********
static void InitializeSystem(void)
{
	USB_rxcnt = 0;
	USB_trflag.data = 0x0;
	USB_txnum = 0L;
	frtimer = 0;
	// ADRo[^
	ANSEL = 0x10;			// AN4:Analog other all Digital
	ANSELH = 0x0;			// AN8-11 all Digital
	ADCON0 = 0x11;			// AN4 Select
	ADCON1 = 0x00;			// Vref Vdd-Vss
	ADCON2 = 0x3e;			// 20Tad,Fosc/64,Left
	// IO|[g
	LATC = 0x40;			// AD7793/CSHigh
	LATB = 0x00;
	TRISA = 0xff;			// RA:all in
	TRISB = 0x30;			// RB4,5:in other:out
	TRISC = 0x01;			// RC0:in other:out
	// MSSP(SPI[h)
	SSPSTAT = 0x01;			// SMP:0,CKE:0,BF:full
	SSPCON1 = 0x32;			// NonWC,SSPon,CKP:1,Fosc/64(375KHz)
	// Timer0 
	T0CON = 0x83;			// Internal 1/16 16bit
	TMR0H = 0x0;			// 48MHz/4/16/375=1KHz(1mS)
	TMR0L = 0x0;    
	// Timer2 
//	T2CON = 0x16;			// pre:1/16,post:1/3,on
//	IPR1bits.TMR2IP = 1;
	PR2 = 0xfa;
	// CCP1 
//	CCP1CON = 0x0c;			// PWMmode LSB:00
//	CCPR1L  = 0x7d;
	// USART 
	RCSTA = 0x90;			// USART enable,8bit
	TXSTA = 0x26;			// SYNC=0,BRGH=1
	SPBRG = 51;			// BRG = 51 (115200bps)
	SPBRGH = 0x0;
	BAUDCON = 0x8;			// DTRXP noninv,CKTXP norm,BRG16=1,ABDEN off
	// 荞݋
	INTCONbits.TMR0IE = 1;	// Timer0 interrupt enable
//	PIE1bits.TMR2IE = 1;	// Timer2 interrupt enable
//	PIE1bits.RCIE = 1;		// USART rx interrupt enable
	INTCONbits.PEIE=1;
	INTCONbits.GIE = 1;
	USBDeviceInit();		//usb_device.c.  Initializes USB module SFRs and firmware
    						//variables to known states.
}//end InitializeSystem


// ******************************************************************************************************
// ************** USB Callback Functions ****************************************************************
// ******************************************************************************************************
// The USB firmware stack will call the callback functions USBCBxxx() in response to certain USB related
// events.  For example, if the host PC is powering down, it will stop sending out Start of Frame (SOF)
// packets to your device.  In response to this, all USB devices are supposed to decrease their power
// consumption from the USB Vbus to <2.5mA each.  The USB module detects this condition (which according
// to the USB specifications is 3+ms of no bus activity/SOF packets) and then calls the USBCBSuspend()
// function.  You should modify these callback functions to take appropriate actions for each of these
// conditions.  For example, in the USBCBSuspend(), you may wish to add code that will decrease power
// consumption from Vbus to <2.5mA (such as by clock switching, turning off LEDs, putting the
// microcontroller to sleep, etc.).  Then, in the USBCBWakeFromSuspend() function, you may then wish to
// add code that undoes the power saving things done in the USBCBSuspend() function.

// The USBCBSendResume() function is special, in that the USB stack will not automatically call this
// function.  This function is meant to be called from the application firmware instead.  See the
// additional comments near the function.

/******************************************************************************
 * Function:        void USBCBSuspend(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        Call back that is invoked when a USB suspend is detected
 *
 * Note:            None
 *****************************************************************************/
void USBCBSuspend(void)
{
	//Example power saving code.  Insert appropriate code here for the desired
	//application behavior.  If the microcontroller will be put to sleep, a
	//process similar to that shown below may be used:
	
	//ConfigureIOPinsForLowPower();
	//SaveStateOfAllInterruptEnableBits();
	//DisableAllInterruptEnableBits();
	//EnableOnlyTheInterruptsWhichWillBeUsedToWakeTheMicro();	//should enable at least USBActivityIF as a wake source
	//Sleep();
	//RestoreStateOfAllPreviouslySavedInterruptEnableBits();	//Preferrably, this should be done in the USBCBWakeFromSuspend() function instead.
	//RestoreIOPinsToNormal();									//Preferrably, this should be done in the USBCBWakeFromSuspend() function instead.

	//IMPORTANT NOTE: Do not clear the USBActivityIF (ACTVIF) bit here.  This bit is 
	//cleared inside the usb_device.c file.  Clearing USBActivityIF here will cause 
	//things to not work as intended.	
	

    #if defined(__C30__)
    #if 0
        U1EIR = 0xFFFF;
        U1IR = 0xFFFF;
        U1OTGIR = 0xFFFF;
        IFS5bits.USB1IF = 0;
        IEC5bits.USB1IE = 1;
        U1OTGIEbits.ACTVIE = 1;
        U1OTGIRbits.ACTVIF = 1;
        Sleep();
    #endif
    #endif
}


/******************************************************************************
 * Function:        void _USB1Interrupt(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is called when the USB interrupt bit is set
 *					In this example the interrupt is only used when the device
 *					goes to sleep when it receives a USB suspend command
 *
 * Note:            None
 *****************************************************************************/
#if 0
void __attribute__ ((interrupt)) _USB1Interrupt(void)
{
    #if !defined(self_powered)
        if(U1OTGIRbits.ACTVIF)
        {
            IEC5bits.USB1IE = 0;
            U1OTGIEbits.ACTVIE = 0;
            IFS5bits.USB1IF = 0;
        
            //USBClearInterruptFlag(USBActivityIFReg,USBActivityIFBitNum);
            USBClearInterruptFlag(USBIdleIFReg,USBIdleIFBitNum);
            //USBSuspendControl = 0;
        }
    #endif
}
#endif

/******************************************************************************
 * Function:        void USBCBWakeFromSuspend(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The host may put USB peripheral devices in low power
 *					suspend mode (by "sending" 3+ms of idle).  Once in suspend
 *					mode, the host may wake the device back up by sending non-
 *					idle state signalling.
 *					
 *					This call back is invoked when a wakeup from USB suspend 
 *					is detected.
 *
 * Note:            None
 *****************************************************************************/
void USBCBWakeFromSuspend(void)
{
	// If clock switching or other power savings measures were taken when
	// executing the USBCBSuspend() function, now would be a good time to
	// switch back to normal full power run mode conditions.  The host allows
	// a few milliseconds of wakeup time, after which the device must be 
	// fully back to normal, and capable of receiving and processing USB
	// packets.  In order to do this, the USB module must receive proper
	// clocking (IE: 48MHz clock must be available to SIE for full speed USB
	// operation).
}

/********************************************************************
 * Function:        void USBCB_SOF_Handler(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The USB host sends out a SOF packet to full-speed
 *                  devices every 1 ms. This interrupt may be useful
 *                  for isochronous pipes. End designers should
 *                  implement callback routine as necessary.
 *
 * Note:            None
 *******************************************************************/
void USBCB_SOF_Handler(void)
{
    // No need to clear UIRbits.SOFIF to 0 here.
    // Callback caller is already doing that.
}

/*******************************************************************
 * Function:        void USBCBErrorHandler(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The purpose of this callback is mainly for
 *                  debugging during development. Check UEIR to see
 *                  which error causes the interrupt.
 *
 * Note:            None
 *******************************************************************/
void USBCBErrorHandler(void)
{
    // No need to clear UEIR to 0 here.
    // Callback caller is already doing that.

	// Typically, user firmware does not need to do anything special
	// if a USB error occurs.  For example, if the host sends an OUT
	// packet to your device, but the packet gets corrupted (ex:
	// because of a bad connection, or the user unplugs the
	// USB cable during the transmission) this will typically set
	// one or more USB error interrupt flags.  Nothing specific
	// needs to be done however, since the SIE will automatically
	// send a "NAK" packet to the host.  In response to this, the
	// host will normally retry to send the packet again, and no
	// data loss occurs.  The system will typically recover
	// automatically, without the need for application firmware
	// intervention.
	
	// Nevertheless, this callback function is provided, such as
	// for debugging purposes.
}


/*******************************************************************
 * Function:        void USBCBCheckOtherReq(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        When SETUP packets arrive from the host, some
 * 					firmware must process the request and respond
 *					appropriately to fulfill the request.  Some of
 *					the SETUP packets will be for standard
 *					USB "chapter 9" (as in, fulfilling chapter 9 of
 *					the official USB specifications) requests, while
 *					others may be specific to the USB device class
 *					that is being implemented.  For example, a HID
 *					class device needs to be able to respond to
 *					"GET REPORT" type of requests.  This
 *					is not a standard USB chapter 9 request, and 
 *					therefore not handled by usb_device.c.  Instead
 *					this request should be handled by class specific 
 *					firmware, such as that contained in usb_function_hid.c.
 *
 * Note:            None
 *******************************************************************/
void USBCBCheckOtherReq(void)
{
    USBCheckCDCRequest();
}//end


/*******************************************************************
 * Function:        void USBCBStdSetDscHandler(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The USBCBStdSetDscHandler() callback function is
 *					called when a SETUP, bRequest: SET_DESCRIPTOR request
 *					arrives.  Typically SET_DESCRIPTOR requests are
 *					not used in most applications, and it is
 *					optional to support this type of request.
 *
 * Note:            None
 *******************************************************************/
void USBCBStdSetDscHandler(void)
{
    // Must claim session ownership if supporting this request
}//end


/*******************************************************************
 * Function:        void USBCBInitEP(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is called when the device becomes
 *                  initialized, which occurs after the host sends a
 * 					SET_CONFIGURATION (wValue not = 0) request.  This 
 *					callback function should initialize the endpoints 
 *					for the device's usage according to the current 
 *					configuration.
 *
 * Note:            None
 *******************************************************************/
void USBCBInitEP(void)
{
    CDCInitEP();
}

/********************************************************************
 * Function:        void USBCBSendResume(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The USB specifications allow some types of USB
 * 					peripheral devices to wake up a host PC (such
 *					as if it is in a low power suspend to RAM state).
 *					This can be a very useful feature in some
 *					USB applications, such as an Infrared remote
 *					control	receiver.  If a user presses the "power"
 *					button on a remote control, it is nice that the
 *					IR receiver can detect this signalling, and then
 *					send a USB "command" to the PC to wake up.
 *					
 *					The USBCBSendResume() "callback" function is used
 *					to send this special USB signalling which wakes 
 *					up the PC.  This function may be called by
 *					application firmware to wake up the PC.  This
 *					function should only be called when:
 *					
 *					1.  The USB driver used on the host PC supports
 *						the remote wakeup capability.
 *					2.  The USB configuration descriptor indicates
 *						the device is remote wakeup capable in the
 *						bmAttributes field.
 *					3.  The USB host PC is currently sleeping,
 *						and has previously sent your device a SET 
 *						FEATURE setup packet which "armed" the
 *						remote wakeup capability.   
 *
 *					This callback should send a RESUME signal that
 *                  has the period of 1-15ms.
 *
 * Note:            Interrupt vs. Polling
 *                  -Primary clock
 *                  -Secondary clock ***** MAKE NOTES ABOUT THIS *******
 *                   > Can switch to primary first by calling USBCBWakeFromSuspend()
 
 *                  The modifiable section in this routine should be changed
 *                  to meet the application needs. Current implementation
 *                  temporary blocks other functions from executing for a
 *                  period of 1-13 ms depending on the core frequency.
 *
 *                  According to USB 2.0 specification section 7.1.7.7,
 *                  "The remote wakeup device must hold the resume signaling
 *                  for at lest 1 ms but for no more than 15 ms."
 *                  The idea here is to use a delay counter loop, using a
 *                  common value that would work over a wide range of core
 *                  frequencies.
 *                  That value selected is 1800. See table below:
 *                  ==========================================================
 *                  Core Freq(MHz)      MIP         RESUME Signal Period (ms)
 *                  ==========================================================
 *                      48              12          1.05
 *                       4              1           12.6
 *                  ==========================================================
 *                  * These timing could be incorrect when using code
 *                    optimization or extended instruction mode,
 *                    or when having other interrupts enabled.
 *                    Make sure to verify using the MPLAB SIM's Stopwatch
 *                    and verify the actual signal on an oscilloscope.
 *******************************************************************/
void USBCBSendResume(void)
{
    static WORD delay_count;
    
    USBResumeControl = 1;                // Start RESUME signaling
    
    delay_count = 1800U;                // Set RESUME line for 1-13 ms
    do
    {
        delay_count--;
    }while(delay_count);
    USBResumeControl = 0;
}


/*******************************************************************
 * Function:        void USBCBEP0DataReceived(void)
 *
 * PreCondition:    ENABLE_EP0_DATA_RECEIVED_CALLBACK must be
 *                  defined already (in usb_config.h)
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is called whenever a EP0 data
 *                  packet is received.  This gives the user (and
 *                  thus the various class examples a way to get
 *                  data that is received via the control endpoint.
 *                  This function needs to be used in conjunction
 *                  with the USBCBCheckOtherReq() function since 
 *                  the USBCBCheckOtherReq() function is the apps
 *                  method for getting the initial control transfer
 *                  before the data arrives.
 *
 * Note:            None
 *******************************************************************/
#if defined(ENABLE_EP0_DATA_RECEIVED_CALLBACK)
void USBCBEP0DataReceived(void)
{
}
#endif

/*******************************************************************
 * Function:        BOOL USER_USB_CALLBACK_EVENT_HANDLER(
 *                        USB_EVENT event, void *pdata, WORD size)
 *
 * PreCondition:    None
 *
 * Input:           USB_EVENT event - the type of event
 *                  void *pdata - pointer to the event data
 *                  WORD size - size of the event data
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is called from the USB stack to
 *                  notify a user application that a USB event
 *                  occured.  This callback is in interrupt context
 *                  when the USB_INTERRUPT option is selected.
 *
 * Note:            None
 *******************************************************************/
BOOL USER_USB_CALLBACK_EVENT_HANDLER(USB_EVENT event, void *pdata, WORD size)
{
    switch(event)
    {
        case EVENT_CONFIGURED: 
            USBCBInitEP();
            break;
        case EVENT_SET_DESCRIPTOR:
            USBCBStdSetDscHandler();
            break;
        case EVENT_EP0_REQUEST:
            USBCBCheckOtherReq();
            break;
        case EVENT_SOF:
            USBCB_SOF_Handler();
            break;
        case EVENT_SUSPEND:
            USBCBSuspend();
            break;
        case EVENT_RESUME:
            USBCBWakeFromSuspend();
            break;
        case EVENT_BUS_ERROR:
            USBCBErrorHandler();
            break;
        case EVENT_TRANSFER:
            Nop();
            break;
        default:
            break;
    }      
    return TRUE; 
}


/** EOF main.c *************************************************/

